#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <search.h>
#include <set>
#include <map>
#include <string>
#include "gmp.h"
#include <time.h>
#include <search.h>
#include <fstream>

#define n 0
#define TRUE 1
#define FALSE 0
#define querylen 20
#define MAX 1000001
#define PN 350000
#define NUM 200


using namespace std;

typedef long clock_t;

typedef struct
{
   int 	seqNum;
   double  minSup;
   int  maxLen;
   int  attNum;
   set<string> items;
   map<string,int> stat;
   set<string> rt;
   int itemcount;
   set<string> itemi;

}
CountInfo;

typedef struct
{
	string s;
	int level;
	string lastv;
}
Node;

void buildtable(CountInfo *info, int *temp)
{
	char *tp1,otp[1024];
	int i,j,total,k,*tp;
	string ntp;

	total=(int)pow(2.0,info->attNum)-1;
	tp=(int *)malloc(sizeof(int)*info->attNum);
	for(i=1;i<=total;i++)
	{
		j=info->attNum-1;
		k=i;
		while(k>0)
		{
			tp[j--]=k%2;
			k=k/2;
		}
		for(;j>=0;j--)
			tp[j]=0;
		ntp="";
		for(j=0;j<info->attNum;j++)
		{
			if(tp[j]==1)
			{
				sprintf(otp,"%d-",temp[j]);
				ntp=ntp+otp;
			}
		}
		if(info->stat.find(ntp)==info->stat.end())
		{
			info->stat.insert( pair<string,int>(ntp,1));
		}
		else
		{
			info->stat[ntp]++;
		}
	}

}

int readfile(CountInfo *info, int ***seq, int *sqlen, char *dir)
{
	FILE *fp;
	char temp[1024],fn[1024];
	set<int>::iterator it;
	map<string,int>::iterator mapit;
	int i,j,k;

	info->itemcount=0;
	info->items.clear();
	info->stat.clear();
	info->itemi.clear();
	info->maxLen=0;

	sprintf(fn,"./%s/sqlen.txt",dir);
	if((fp=fopen(fn,"r"))==NULL)
	{
		printf("cannot open file %s\n",fn);
		return 0;
	}
	i=0;
	while(i<info->seqNum)
	{
		fscanf(fp,"%s", temp);
		sqlen[i]=atoi(temp);
		if(info->maxLen<sqlen[i])
			info->maxLen=sqlen[i];
		seq[i]=(int **)malloc(sizeof(int *)*sqlen[i]);
		for(j=0;j<sqlen[i];j++)
			seq[i][j]=(int *)malloc(sizeof(int)*info->attNum);
		i++;
	}

	fclose(fp);

	sprintf(fn,"./%s/data.txt",dir);

	if((fp=fopen(fn,"r"))==NULL)
	{
		printf("cannot open file %s\n",fn);
		return 0;
	}

	for(i=0;i<info->seqNum;i++)
	{
		if(i%1000==0)
			printf("read seq %d\n",i);
		for(j=0;j<sqlen[i];j++)
		{
			for(k=0;k<info->attNum;k++)
			{
				fscanf(fp,"%s",temp);
				//store data in seq
				seq[i][j][k]=atoi(temp);
			}
			buildtable(info,seq[i][j]); //build lookup table
		}

	}
	fclose(fp);
	info->itemcount=info->items.size();
	for(mapit=info->stat.begin();mapit!=info->stat.end();mapit++)
	{
		if(mapit->second>=info->seqNum*info->minSup)
		{
			info->items.insert(mapit->first);
			info->itemi.insert(mapit->first);
		}

	}

	return 0;
}



int checknode(CountInfo *info, Node *cur, mpz_t **ens, mpz_t *pdata,int *sqlen, int ***seq)
{
	int i,j,k,l,h,rt,**pt1,**pt2,negcount,count,qlen,*attlen,*mark,**query;
	mpz_t **qcode,tp1,tp2;
	char *cstr,*p,*q,**nstr;
	int flagl,flagu;

	//decode cur
	mpz_init_set_str(tp1,"0",10);
  	mpz_init_set_str(tp2,"0",10);
	attlen=(int *)malloc(sizeof(int)*info->maxLen);
	mark=(int *)malloc(sizeof(int)*info->seqNum);
	query=(int **)malloc(sizeof(int *)*info->maxLen);
	qcode=(mpz_t **)malloc(sizeof(mpz_t *)*info->maxLen);
	for(i=0;i<info->maxLen;i++)
	{
		query[i]=(int *)malloc(sizeof(int)*info->attNum);
		qcode[i]=(mpz_t *)malloc(sizeof(mpz_t)*info->attNum);
		for(j=0;j<info->attNum;j++)
			mpz_init_set_str(qcode[i][j],"0",10);
	}
	cstr = new char [cur->s.size()+1];
	nstr = (char **)malloc(sizeof(char *)*info->maxLen);
	strcpy (cstr, cur->s.c_str());
	i=0;
	p=strtok (cstr,",");
	while (p!=NULL)
	{
		nstr[i]=(char *)malloc(sizeof(char)*info->attNum*2);
		strcpy(nstr[i],p);
		p=strtok(NULL,",");
		i++;
	}
	qlen=i;
	for(i=0;i<qlen;i++)
	{
		j=0;
		q=strtok(nstr[i],"-");
		while(q!=NULL)
		{
			query[i][j]=atoi(q);
			mpz_set(qcode[i][j],pdata[query[i][j]]);
			j++;
			q=strtok(NULL,"-");
		}
		attlen[i]=j;
	}
	//call checking
	pt1=(int **)malloc(sizeof(int *)*qlen);
	pt2=(int **)malloc(sizeof(int *)*qlen);
	for(i=0;i<qlen;i++)
	{
		pt1[i]=(int *)malloc(sizeof(int)*attlen[i]);
        pt2[i]=(int *)malloc(sizeof(int)*attlen[i]);
	}
	negcount=count=0;
	for(i=0;i<info->seqNum;i++)
	{
		mark[i]=0;
		for(j=0;j<qlen;j++)
		{
			for(k=0;k<attlen[j];k++)
			{
				if(mpz_divisible_p(ens[i][0],qcode[j][k])==0)
				{
					mark[i]=1;
					break;
				}

			}
			if(mark[i]==1)
				break;
		}
		if(mark[i]==1)
		{
			negcount++;
		}
		else
		{
			flagl=flagu=0;
			j=0;
			k=0;

				while(k<qlen && j<sqlen[i])
				{
					//compare seq[i][j] and query[k][]
					h=0;
					for(l=0;l<attlen[k] && h<info->attNum;)
					{
						if(seq[i][j][h]!=query[k][l])
						{
							h++;
						}
						else
						{
							l++;
							h++;
						}
					}
					if(l==attlen[k])
					{
						k++;
						j++;
					}
					else
						j++;

				}
				if(k==qlen)
					count++;
				else
					negcount++;

		}
		if (negcount+info->minSup*info->seqNum>info->seqNum)
		{
			rt=0;
			break;
		}
		if(count>=info->minSup*info->seqNum)
		{
			rt=1;
			break;
		}
	}

	mpz_clear(tp1);
	mpz_clear(tp2);
	for(i=0;i<info->maxLen;i++)
	{
		for(j=0;j<info->attNum;j++)
			mpz_clear(qcode[i][j]);
		free(qcode[i]);
	}
	free(mark);


	if(count>=info->minSup*info->seqNum)
		rt=1;
	else
		rt=0;

	return rt;
}

void findfreqpattern(CountInfo *info, Node *cur, mpz_t **ens, mpz_t *pdata, int *sqlen, int ***seq)
{
	int i,count,curlevel;
	set<string> itemp;
	set<string> stemp;
	set<string> curstemp, curitemp;
	set<string>::iterator it;
	set<string>::iterator nit;
	string ext,last;
	size_t length,pos;
	char *tp=new char[1024];

	curstemp.clear();
	curitemp.clear();
	itemp.clear();
	stemp.clear();
	for (it=info->itemi.begin();it!=info->itemi.end();it++)
	{
		curitemp.insert(*it);
	}
	for (it=info->items.begin();it!=info->items.end();it++)
	{
		curstemp.insert(*it);
	}


	curlevel=cur->level;
	ext=cur->s;
	if(cur->level<info->maxLen)
	{
		cur->level++;

		for (it=curstemp.begin();it!=curstemp.end();it++)
		{
			cur->s=ext;
			if(!ext.empty())
			{
				cur->s.insert(cur->s.length(),","+*it);
			}
			else
			{
				cur->s.insert(cur->s.length(),*it);
			}
			cur->lastv=*it;
			//check new cur
			count=checknode(info,cur,ens,pdata,sqlen,seq);
			if(count==1)
			{
				info->rt.insert(cur->s);
				stemp.insert(*it);
			}

		}

		for (it=stemp.begin();it!=stemp.end();it++)
		{
			cur->s=ext;
			if(!ext.empty())
			{
				cur->s.insert(cur->s.length(),","+(*it));

			}
			else
			{
				cur->s.insert(cur->s.length(),(*it));
			}
			cur->lastv=*it;

			info->items.clear();
			for(nit=stemp.begin();nit!=stemp.end();nit++)
			{
				info->items.insert(*nit);
			}
			info->itemi.clear();
			nit=stemp.find(cur->lastv);
			for(nit++;nit!=stemp.end();nit++)
			{
				info->itemi.insert(*nit);
			}
			findfreqpattern(info,cur,ens,pdata,sqlen,seq);
		}


	}

	curstemp.clear();
	curitemp.clear();
	itemp.clear();
	stemp.clear();
	curstemp.~set();
	itemp.~set();
	stemp.~set();
	curitemp.~set();
	free(tp);
}

void EC(mpz_t **ens, int ***data, mpz_t *pdata, int etlen, int i, mpz_t *oldprime, mpz_t *newprime, int alen)
{
	mpz_t CN,EL,EU,*N,*prime,tp,tp1,tp2,*c,tp3;
	int nprime=0;
	int *a,*b;
	int j,k,l;
	int ct=0;
	//int alen=6;
	int maxlen;

	maxlen=etlen*(alen-2);

	//printf("%d\n",maxlen);

	prime = (mpz_t *)malloc(sizeof(mpz_t)*(alen-2));
	N = (mpz_t *)malloc(sizeof(mpz_t)*maxlen);
	c = (mpz_t *)malloc(sizeof(mpz_t)*maxlen);
	a = (int *)malloc(sizeof(int)*maxlen);
	b = (int *)malloc(sizeof(int)*maxlen);
	//printf("%d\n",alen);
	//printf("sq:%d-----------------AA\n",i);
		mpz_init_set_str(CN,"1",10);
		mpz_init_set_str(EL,"0",10);
		mpz_init_set_str(EU,"0",10);
		mpz_init_set_str(tp1,"1",10);
		mpz_init_set_str(tp,"0",10);
		mpz_init_set_str(tp2,"1",10);
		for(j=0;j<alen-2;j++)
		{
			mpz_init(prime[j]);
		}
		for(j=0;j<etlen*(alen-2);j++)
		{
			mpz_init(N[j]);
			mpz_init(c[j]);
			a[j]=0;
			b[j]=0;
		}
		for(j=0;j<etlen;j++)
		{
			for(k=0;k<alen-2;k++)
			{
				if(mpz_cmp_si(pdata[data[i][j][k]],(long)0)!=0)//found_item=hsearch(item,FIND))!=NULL) //(new_inv_len[data[i][j][k]]>0)//
				{
					mpz_set(prime[k], pdata[data[i][j][k]]);
				}
				else
				{

					mpz_nextprime(*newprime, *oldprime);
					mpz_set(pdata[data[i][j][k]],*newprime);
					mpz_set(*oldprime,*newprime);
					mpz_set(prime[k],*newprime);

				}

			}

			for(l=0;l<alen-2;l++)
			{


				if(mpz_divisible_p(CN,prime[l])==0)
				{

					mpz_set(N[ct],prime[l]);
					a[ct]=j+1;
					b[ct]=j+1;
					ct++;
				}
				else
				{
					for(k=0;k<ct;k++)
						if(mpz_cmp(N[k],prime[l])==0)
							break;
					b[k]=j+1;
				}
				mpz_mul(CN,CN,prime[l]);
			}

		}


		mpz_init_set_str(tp3,"1",10);
		for(k=0;k<ct;k++)
		{
			mpz_mul(tp3,tp3,N[k]);
		}
		for(k=0;k<ct;k++)
		{
			mpz_set_str(tp1,"1",10);
			mpz_set_str(tp2,"1",10);
			mpz_set(tp,N[k]);
			mpz_set(N[k],tp1);
			for(l=0;l<ct;l++)
			{
				mpz_mul(tp1,tp1,N[l]);
			}

			mpz_set(c[k],tp1);
			mpz_set(N[k],tp);
			mpz_gcdext(tp2,tp,tp1,N[k],c[k]);
			mpz_mul(c[k],c[k],tp1);

			mpz_set_si(tp1,(long)a[k]);
			mpz_mul(tp,c[k],tp1);
			mpz_add(EL,EL,tp);

			mpz_set_si(tp1,(long)b[k]);
			mpz_mul(tp,c[k],tp1);
			mpz_add(EU,EU,tp);
		}

		//printf("DD\n");

		mpz_mod(EL,EL,tp3);
		mpz_mod(EU,EU,tp3);
		mpz_set(ens[i][0],CN);
		mpz_set(ens[i][1],EL);
		mpz_set(ens[i][2],EU);

		mpz_clear(CN);
		mpz_clear(EL);
		mpz_clear(EU);
		mpz_clear(tp);
		mpz_clear(tp1);
		mpz_clear(tp2);
		mpz_clear(tp3);
		for(j=0;j<maxlen;j++)
		{
			mpz_clear(N[j]);
			mpz_clear(c[j]);
		}
		for(j=0;j<alen-2;j++)
			mpz_clear(prime[j]);

		free(N);
		free(c);
		free(prime);
		free(a);
		free(b);

}


int printseq(CountInfo *info,char *fn,double miningtime)
{
	set<string>::iterator it;
	ofstream fs;

	fs.open(fn);

	streambuf *buf = cout.rdbuf ();


	cout.rdbuf(fs.rdbuf());

	cout << " " << miningtime;;
	cout  << " " << info->rt.size() ;



	for(it=info->rt.begin();it!=info->rt.end();it++)
	{
		cout << " \n"<< *it ;
	}
	fs.flush();
	fs.close();
	cout.rdbuf(buf);
	return 0;

}
int main(int argc, char **argv)
{
	int ***seq,*sqlen,i;
	CountInfo info;
	set<string>::iterator it;
	set<string> tempset;
	char temp[1024];
	set<char *> rt;
	Node cur;
	string tp;
	mpz_t oldprime,newprime,*N,*prime,tp1,tp2,**query,*c,*pdata,**ens;
	clock_t miningStart, miningEnd;
    double programDuration;
    double miningDuration;
    char fn[1024];

	//read data;
	info.minSup=atof(argv[1]);
	info.seqNum=atoi(argv[2]);
	info.attNum=atoi(argv[3]);
	sprintf(fn,"./%s/freqseq.txt",argv[4]);
	seq=(int ***)malloc(sizeof(int **)*info.seqNum);
	sqlen=(int *)malloc(sizeof(int)*info.seqNum);
	readfile(&info, seq, sqlen,argv[4]);

	mpz_init_set_str(oldprime,"11",10);
	mpz_init_set_str(newprime,"11",10);

	while(mpz_cmp_si(oldprime,(long)info.maxLen)<0)
	{
		mpz_nextprime(newprime,oldprime);
		mpz_set(oldprime,newprime);
	}



	//Encode seq

	pdata=(mpz_t *)malloc(sizeof(mpz_t)*PN);
	for(i=0;i<PN;i++)
	{
		mpz_init_set_str(pdata[i],"0",10);
	}
	ens=(mpz_t **)malloc(sizeof(mpz_t *)*info.seqNum);

	for(i=0;i<info.seqNum;i++)
	{
		ens[i]=(mpz_t *)malloc(sizeof(mpz_t)*3);
		mpz_init_set_str(ens[i][0],"0",10);
		mpz_init_set_str(ens[i][1],"0",10);
		mpz_init_set_str(ens[i][2],"0",10);
	}

	for(i=0;i<info.seqNum;i++)
	{
		if(i%10000==0)
		printf("seq %d:-----------\n",i+1);
		EC(ens,seq,pdata,sqlen[i],i,&oldprime, &newprime, (info.attNum+2));
	}

	//recursive check
	info.rt.clear();
	cur.level=0;
	cur.s="";


	miningStart = clock();
	findfreqpattern(&info,&cur,ens,pdata,sqlen,seq);
    miningEnd = clock();

	miningDuration = (miningEnd - miningStart) / (double)CLOCKS_PER_SEC;

	cout << "Mining Duration:" << miningDuration << endl;

	//print result
	printseq(&info,fn,miningDuration);

	return 0;
}

